//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DimGray
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  LimeGreen
#property indicator_color5  PaleVioletRed
#property indicator_levelcolor DarkSlateGray
#property indicator_width1  1
#property indicator_width2  3
#property indicator_width3  3


extern int    AroonPeriod      = 25;
extern int    Filter           = 50;
extern double Divisor          = 50;
extern string Alerts_Settings  = "Settings for alerts";
extern bool   alerts.On        = false;
extern bool   alerts.OnCurrent = false;
extern bool   alerts.Message   = true;
extern bool   alerts.Sound     = false;
extern bool   alerts.Email     = false;


//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double oscau[];
double oscad[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,oscau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,oscad); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,108);
   SetIndexBuffer(5,trend);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
      Divisor = MathMin(Divisor,100);
   
   IndicatorShortName("Aroon oscillator ("+AroonPeriod+","+DoubleToStr(Divisor,2)+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double AroonUp = 100*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod,i)+i)/AroonPeriod;
      double AroonDn = 100*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod,i)+i)/AroonPeriod;
      double Aroon   = (AroonUp-AroonDn)/Divisor;
         osc[i] = 100.0*(MathExp(2.0*Aroon)-1)/(MathExp(2.0*Aroon)+1.0);
      
//         osc[i] = Aroon; continue;
         osclu[i] = EMPTY_VALUE;
         oscld[i] = EMPTY_VALUE;
         oscau[i] = EMPTY_VALUE;
         oscad[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (osc[i] >  Filter)                     trend[i] =  1;
            if (osc[i] < -Filter)                     trend[i] = -1;
            if (osc[i] <  Filter && osc[i] > -Filter) trend[i] = 0;
            if (trend[i] == 1)
            {
               osclu[i] = osc[i]; if (trend[i]!=trend[i+1]) oscau[i] = osc[i];
            }
            if (trend[i] == -1)
            {
               oscld[i] = osc[i]; if (trend[i]!=trend[i+1]) oscad[i] = osc[i];
            }
   }
   
   //
   //
   //
   //
   //
   
   if (alerts.On)
   {
      if (alerts.OnCurrent)
            int forBar = 0;
      else      forBar = 1;
      
      //
      //
      //
      //
      //

      if (oscau[forBar]!= EMPTY_VALUE) doAlert("Arron oscillator trend chaned to UP");
      if (oscad[forBar]!= EMPTY_VALUE) doAlert("Arron oscillator trend chaned to DOWN");
   }      
   return(0);
}


//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Aroon oscillator - ",doWhat);
          if (alerts.Message) Alert(message);
          if (alerts.Email)   SendMail("Arron oscillator",message);
          if (alerts.Sound)   PlaySound("alert2.wav");
   }
}